import numpy as np

# Define the objective function and its gradient
def f(x,y):
    return 5*x**2-6*x*y+5*y**2

def fx(x,y):
    return 10*x-6*y

def fy(x,y):
    return -6*x+10*y

# Initialization
x0  ,y0   = -0.5,-0.1
xk  ,yk   = x0,y0
xkp1,ykp1 = xk,yk
tk    = 0.1

# Coordinate Descent and Gradient Descent method
method = "CD"   # Option for Coordinate Descent(CD) or Gradient Descent(GD)
eps = 1e-10
iter = 0
if method == "CD":
    while True:
        xkp1 = xk-tk*fx(xk  ,yk)
        ykp1 = yk-tk*fy(xkp1,yk)
        
        if np.sqrt((xkp1-xk)**2+(ykp1-yk)**2)<eps:
            print("CD converges at iter=", iter)
            print("The optimal point is (",xkp1,",",ykp1,")")
            break
        
        xk,yk= xkp1,ykp1
        iter = iter+1
elif method == "GD":
    while True:
        xkp1 = xk-tk*fx(xk,yk)
        ykp1 = yk-tk*fy(xk,yk)
        
        if np.sqrt((xkp1-xk)**2+(ykp1-yk)**2)<eps:
            print("GD converges at iter=", iter)
            print("The optimal point is (",xkp1,",",ykp1,")")
            break
        
        xk,yk= xkp1,ykp1
        iter = iter+1